<?php 
echo '<div class="wrap">';

if (isset($_POST['info_update'])) 
{
	$updateOption = false;

	/**
	 * Basic Settings
	 */
	// Save Dev Key
	if(architect_save_option('architect_devkey')) $updateOption = true;
	// Save the show blog description
	if(architect_save_option('architect_show_blogdesc')) $updateOption = true;
	// Save the show blog title
	if(architect_save_option('architect_show_blogtitle')) $updateOption = true;
	// Save the mobile blog title
	if(architect_save_option('architect_mobile_blogtitle', array('stripTags' => true))) $updateOption = true;
	// Save the mobile blog description
	if(architect_save_option('architect_mobile_blogdesc', array('stripTags' => true))) $updateOption = true;
	// Save use header image
	if(architect_save_option('architect_use_headerimage')) $updateOption = true;
	// Save actual header image
	if(isset($_FILES['architect_headerimage']))
	{
		$pathToHeader = WP_UPLOAD_DIR.DIRECTORY_SEPARATOR.get_wapl_plugin_base().DIRECTORY_SEPARATOR.'images'.DIRECTORY_SEPARATOR.'header'.DIRECTORY_SEPARATOR;
		architect_check_path($pathToHeader);
		if(move_uploaded_file($_FILES['architect_headerimage']['tmp_name'], $pathToHeader.$_FILES['architect_headerimage']['name']))
		{
			update_option('architect_headerimage', $_FILES['architect_headerimage']['name']);
			$updateOption = true;
		}
	}
	// Save header image BG transparency col
	if(architect_save_option('architect_headerimage_transparency_colour')) $updateOption = true;
	// Is the header image a link back to the homepage
	if(architect_save_option('architect_headerimagelinktohome')) $updateOption = true;
	// Save use footer image
	if(architect_save_option('architect_use_footerimage')) $updateOption = true;
	// Save actual footer image
	if(isset($_FILES['architect_footerimage']))
	{
		$pathToFooter = WP_UPLOAD_DIR.DIRECTORY_SEPARATOR.get_wapl_plugin_base().DIRECTORY_SEPARATOR.'images'.DIRECTORY_SEPARATOR.'footer'.DIRECTORY_SEPARATOR;
		architect_check_path($pathToFooter);
		if(move_uploaded_file($_FILES['architect_footerimage']['tmp_name'], $pathToFooter.$_FILES['architect_footerimage']['name']))
		{
			update_option('architect_footerimage', $_FILES['architect_footerimage']['name']);
			$updateOption = true;
		}
	}
	// Save footer image BG transparency col
	if(architect_save_option('architect_footerimage_transparency_colour')) $updateOption = true;
	// Show footer text
	if(architect_save_option('architect_showfootertext')) $updateOption = true;
	// What is the footer text
	if(architect_save_option('architect_footertext', array('stripTags' => true))) $updateOption = true;
	// Save show menu at top
	if(architect_save_option('architect_showmenuattop')) $updateOption = true;
	// Save show menu at bottom
	if(architect_save_option('architect_showmenuatbottom')) $updateOption = true;
	// Save switch to desktop
	if(architect_save_option('architect_showswitchtodesktop')) $updateOption = true;
	// Save show author
	if(architect_save_option('architect_showauthor')) $updateOption = true;
	
	/**
	 * Advanced
	 */
	
	// Save META tags
	if(architect_save_option('architect_use_meta')) $updateOption = true;
	// Save META keywords
	if(architect_save_option('architect_meta_keywords', array('stripTags' => true))) $updateOption = true;
	// Save page items in menu
	if(isset($_POST['architect_showmenuitems']))
	{
		foreach($_POST['architect_showmenuitems'] as $key => $val)
		{
			$_POST['architect_showmenuitems'][$key] = architectCharsOther($val);
		}
		
		$saveVal = implode('|', $_POST['architect_showmenuitems']);
		if($saveVal != get_option('architect_showmenuitems'))
		{
			update_option('architect_showmenuitems', $saveVal);
			$updateOption = true;
		}
	}
	// Save try and do forms
	if(architect_save_option('architect_doform')) $updateOption = true;
	// Redirection
	if(architect_save_option('architect_redirect')) $updateOption = true;
	if(architect_save_option('architect_redirect_url')) $updateOption = true;
	// Access keys
	if(architect_save_option('architect_accesskeys')) $updateOption = true;
	// 404 page text
	if(architect_save_option('architect_advanced_404text', array('stripTags' => true))) $updateOption = true;
	
	/**
	 * Home page
	 */
	
	// Save show excerpt on home page
	if(architect_save_option('architect_home_showexcerpt')) $updateOption = true;
	// Save home page excerpt override
	if(architect_save_option('architect_home_excerpt_override')) $updateOption = true;
	// Save remove captions
	if(architect_save_option('architect_home_removecaptions')) $updateOption = true;
	// Save home page show categories
	if(architect_save_option('architect_home_showcategories')) $updateOption = true;
	// Save home page show date
	if(architect_save_option('architect_home_showdate')) $updateOption = true;
	// Save home page image scale
	if(architect_save_option('architect_home_imagescale')) $updateOption = true;
	// Save home page image quality
	if(architect_save_option('architect_home_imagequality')) $updateOption = true;
	// Save home page transparency colour
	if(architect_save_option('architect_home_transcol')) $updateOption = true;
	// Save number of posts on home page
	if(architect_save_option('architect_home_posts_per_page')) $updateOption = true;
	// Show first image from post on home page
	if(architect_save_option('architect_home_firstimage')) $updateOption = true;
	// Save show more link
	if(architect_save_option('architect_home_showmore')) $updateOption = true;
	// Save older & newer posts link 
	if(architect_save_option('architect_home_olderposts', array('stripTags' => true))) $updateOption = true;
	if(architect_save_option('architect_home_newerposts', array('stripTags' => true))) $updateOption = true;
	
	/** 
	 * Home page by category 
	 **/
	
	// Turn building by category on
	if(architect_save_option('architect_home_bycat')) $updateOption = true;
	// Number of categories
	if(architect_save_option('architect_home_categories_total')) $updateOption = true;
	// Homepage categories
	$total = get_option('architect_home_categories_total');
	if($total && $total > 0)
	{
		for($i = 1; $i <= $total; $i++)
		{
			if(architect_save_option('architect_home_category_'.$i)) $updateOption = true;
			if(architect_save_option('architect_home_category_'.$i.'_total')) $updateOption = true;
		}
	}
	
	/**
	 * Post Page
	 */ 
	
	// Save use post header image
	if(architect_save_option('architect_single_use_headerimage')) $updateOption = true;
	// Save post header image
	if(isset($_FILES['architect_single_headerimage']))
	{
		$pathToPostHeader = WP_UPLOAD_DIR.DIRECTORY_SEPARATOR.get_wapl_plugin_base().DIRECTORY_SEPARATOR.'images'.DIRECTORY_SEPARATOR.'postHeader'.DIRECTORY_SEPARATOR;
		architect_check_path($pathToPostHeader);
		if(move_uploaded_file($_FILES['architect_single_headerimage']['tmp_name'], $pathToPostHeader.$_FILES['architect_single_headerimage']['name']))
		{
			update_option('architect_single_headerimage', $_FILES['architect_single_headerimage']['name']);
			$updateOption = true;
		}
	}
	// Save post do paging
	if(architect_save_option('architect_single_dopaging')) $updateOption = true;
	// Save post paging length
	if(architect_save_option('architect_single_paginglength')) $updateOption = true;
	// Save show home link
	if(architect_save_option('architect_single_showhome')) $updateOption = true;
	// Save show post next link
	if(architect_save_option('architect_single_shownext')) $updateOption = true;
	// Save show tags
	if(architect_save_option('architect_single_showtags')) $updateOption = true;
	// Save post image scale
	if(architect_save_option('architect_single_imagescale')) $updateOption = true;
	// Save post image quality
	if(architect_save_option('architect_single_imagequality')) $updateOption = true;
	// Save post image transcol
	if(architect_save_option('architect_single_transcol')) $updateOption = true;
	// Save post response format
	if(architect_save_option('architect_single_responseformat')) $updateOption = true;
	// Save allow post comments
	if(architect_save_option('architect_single_allowcomments')) $updateOption = true;
	// Save show post comments
	if(architect_save_option('architect_single_showcomments')) $updateOption = true;
	// Save read more on post
	if(architect_save_option('architect_single_nextpage')) $updateOption = true;
	// Save read less on post
	if(architect_save_option('architect_single_prevpage')) $updateOption = true;
	// Save text for previous post
	if(architect_save_option('architect_single_previouspost', array('stripTags' => true))) $updateOption = true;
	// Save text for next post
	if(architect_save_option('architect_single_nextpost', array('stripTags' => true))) $updateOption = true;
	// Save text for home post
	if(architect_save_option('architect_single_homepost', array('stripTags' => true))) $updateOption = true;
	// Save tag text
	if(architect_save_option('architect_single_tagtext', array('stripTags' => true))) $updateOption = true;
	// Save post language text
	if(architect_save_option('architect_single_metadatatext', array('stripTags' => true, 'tagAllow' => array('date', 'time', 'category')))) $updateOption = true;
	if(architect_save_option('architect_single_commentsaystext', array('stripTags' => true))) $updateOption = true;
	if(architect_save_option('architect_single_commentsingletext', array('stripTags' => true))) $updateOption = true;
	if(architect_save_option('architect_single_commentpluraltext', array('stripTags' => true))) $updateOption = true;
	if(architect_save_option('architect_single_leaveareplytext', array('stripTags' => true))) $updateOption = true;
	if(architect_save_option('architect_single_leaveareplynametext', array('stripTags' => true))) $updateOption = true;
	if(architect_save_option('architect_single_leaveareplyemailtext', array('stripTags' => true))) $updateOption = true;
	if(architect_save_option('architect_single_leaveareplywebsitetext', array('stripTags' => true))) $updateOption = true;
	if(architect_save_option('architect_single_leaveareplycommenttext', array('stripTags' => true))) $updateOption = true;
	if(architect_save_option('architect_single_leaveareplysubmittext', array('stripTags' => true))) $updateOption = true;
	// Passwords
	if(architect_save_option('architect_single_passwordtext', array('stripTags' => true))) $updateOption = true;
	if(architect_save_option('architect_single_passwordbuttontext', array('stripTags' => true))) $updateOption = true;
	
	/**
	 * Page Settings
	 */ 
	
	// Save page image scale
	if(architect_save_option('architect_page_imagescale')) $updateOption = true;
	// Save page image quality
	if(architect_save_option('architect_page_imagequality')) $updateOption = true;
	// Save page  image transcol
	if(architect_save_option('architect_page_transcol')) $updateOption = true;
	
	/**
	 * Archives Settings
	 */
	
	// Category text
	if(architect_save_option('architect_archive_cattext', array('stripTags' => true, 'tagAllow' => array('category')))) $updateOption = true;
	// Tag text
	if(architect_save_option('architect_archive_tagtext', array('stripTags' => true, 'tagAllow' => array('tag')))) $updateOption = true;
	// Date text
	if(architect_save_option('architect_archive_datetext', array('stripTags' => true))) $updateOption = true;
	// Author archive text
	if(architect_save_option('architect_archive_authortext', array('stripTags' => true))) $updateOption = true;
	// Blog archive text
	if(architect_save_option('architect_archive_blogarchivetext', array('stripTags' => true))) $updateOption = true;
	// Archive home link
	if(architect_save_option('architect_archive_hometext', array('stripTags' => true))) $updateOption = true;
	// Archive older entries link
	if(architect_save_option('architect_archive_olderentriestext', array('stripTags' => true))) $updateOption = true;
	// Archive newer entries link
	if(architect_save_option('architect_archive_newerentriestext', array('stripTags' => true))) $updateOption = true;
	// No category posts text
	if(architect_save_option('architect_archive_nocattext', array('stripTags' => true, 'tagAllow' => array('category')))) $updateOption = true;
	// No date posts text
	if(architect_save_option('architect_archive_nodatetext', array('stripTags' => true))) $updateOption = true;
	// No author posts text
	if(architect_save_option('architect_archive_noauthortext', array('stripTags' => true, 'tagAllow' => array('author')))) $updateOption = true;
	// No posts found text
	if(architect_save_option('architect_archive_nopoststext', array('stripTags' => true))) $updateOption = true;
	
	/**
	 * Search Settings
	 */ 
	
	// Save home show search
	if(architect_save_option('architect_home_showsearch')) $updateOption = true;
	// Save search page show tags
	if(architect_save_option('architect_search_showtags')) $updateOption = true;
	// Save search page show categories
	if(architect_save_option('architect_search_showcategories')) $updateOption = true;
	// Search page title
	if(architect_save_option('architect_search_title', array('stripTags' => true))) $updateOption = true;
	// Link to home
	if(architect_save_option('architect_search_hometext', array('stripTags' => true))) $updateOption = true;
	// Link to older entries
	if(architect_save_option('architect_search_olderentriestext', array('stripTags' => true))) $updateOption = true;
	// Link to newer entries
	if(architect_save_option('architect_search_newerentriestext', array('stripTags' => true))) $updateOption = true;
	// "Written by" text
	if(architect_save_option('architect_search_writtenbytext', array('stripTags' => true))) $updateOption = true;
	// "Tags" text
	if(architect_save_option('architect_search_tagstext', array('stripTags' => true))) $updateOption = true;
	// "Posted in" text
	if(architect_save_option('architect_search_postedintext', array('stripTags' => true))) $updateOption = true;
	// "No posts found" text
	if(architect_save_option('architect_search_notext', array('stripTags' => true))) $updateOption = true;
	// Search box title
	if(architect_save_option('architect_search_boxtitletext', array('stripTags' => true))) $updateOption = true;
	// Search box submit value
	if(architect_save_option('architect_search_boxsubmittext', array('stripTags' => true))) $updateOption = true;
	
	
	/**
	 * Theme Settings
	 */
	// Save Mobile stylesheet
	$file = WP_UPLOAD_DIR.DIRECTORY_SEPARATOR.get_wapl_plugin_base().DIRECTORY_SEPARATOR.'css'.DIRECTORY_SEPARATOR.'style.css';
	architect_check_path(WP_UPLOAD_DIR.DIRECTORY_SEPARATOR.get_wapl_plugin_base().DIRECTORY_SEPARATOR.'css'.DIRECTORY_SEPARATOR);
	
	if(is_readable($file))
	{
		$stylesheet = file_get_contents($file);
	} else
	{
		$stylesheet = '';
	}
	
	if(!file_exists($file))
	{
		// Create file if it doesn't exist
		@file_put_contents($file, "");
	}
	
	if(is_writable($file))
	{
		if(stripslashes($_POST['architect_stylesheet']) != $stylesheet)
		{
			if(file_put_contents($file, stripslashes($_POST['architect_stylesheet'])))
			{
				$updateOption = true;
			}
		}
	} else
	{
		echo '<div class="updated architectInitError"><p>"'.$file.'" is not writable - change the permissions to save the stylesheet!</p></div>';
	}
	
	// Save custom stylesheet
	$custom_file = WP_UPLOAD_DIR.DIRECTORY_SEPARATOR.get_wapl_plugin_base().DIRECTORY_SEPARATOR.'css'.DIRECTORY_SEPARATOR.'custom_style.css';
	
	if(is_readable($custom_file))
	{
		$custom_stylesheet = file_get_contents($custom_file);
	} else
	{
		$custom_stylesheet = '';
	}
	
	if(!file_exists($custom_file))
	{
		// Create file if it doesn't exist
		@file_put_contents($custom_file, "");
	}
	
	if(is_writable($custom_file))
	{
		if(stripslashes($_POST['architect_custom_stylesheet']) != $custom_stylesheet)
		{
			if(file_put_contents($custom_file, stripslashes($_POST['architect_custom_stylesheet'])))
			{
				$updateOption = true;
			}
		}
	} else
	{
		echo '<div class="updated architectInitError"><p>"'.$custom_file.'" is not writable - change the permissions to save the stylesheet!</p></div>';
	}
	
	if($updateOption)
	{
		echo "<div class='updated fade'><p><strong>Wapple Architect settings saved.</strong></p></div>";
	}
}

// Architect Errors
if(get_option('architect_devkey') == '' OR !get_option('architect_devkey'))
{
	echo '<div class="updated architectInitError"><p><strong>You haven\'t saved your free Wapple Architect Dev Key, get one from here: <a href="http://wapple.net/register/free-developer-program-for-coding-mobile-web.htm">http://wapple.net/register/free-developer-program-for-coding-mobile-web.htm</a></strong></p></div>';
}
if(!function_exists('simplexml_load_string'))
{
	echo '<div class="updated architectInitError"><p>You do not have simpleXML installed, this plugin needs simpleXML in order to parse XML returned from Wapple\'s web services</p></div>';
}
if(isset($_COOKIE['architectError']))
{
	echo '<div class="updated architectInitError"><p>Error initializing mobile version: '.$_COOKIE['architectError'].'</p></div>';
}

echo '<form method="post" action="options-general.php?page=architect.php" enctype="multipart/form-data">';
echo architect_admin_header('2', 'Wapple Architect Settings Dashboard');

echo '<p><em>Wapple Architect WordPress plugin is brought to you by Rich Gubby - <a href="http://mobilewebjunkie.com">http://mobilewebjunkie.com</a></em></p>';

// Basic Settings
$oldVersion = true;
require_once('options-basic.php');

// Advanced Settings
require_once('options-advanced.php');

// Home page settings
require_once('options-home.php');

// Build homepage by category settings
require_once('options-homecat.php');

// Posts Page Settings
require_once('options-posts.php');

// Pages Settings
require_once('options-pages.php');

// Archives Settings
require_once('options-archives.php');

// Search Results Settings
require_once('options-search.php');

// Mobile Theme Settings
require_once('options-theme.php');

echo '<table class="form-table" cellspacing="2" cellpadding="5" width="100%"><tr><td><p class="submit"><input class="button-primary" type="submit" name="info_update" value="Save Changes" /></p></td></tr></table>';
echo '</form></div>';
?>